#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "s3vn.h"

int main(int argc, char **argv)
{

  int rc;
  char buf[1000];

  char *tmp_repo_name = tempnam("/tmp", "svnz-");
  printf("Temporary name is %s\n", tmp_repo_name);

  // DEBUG
  snprintf(buf, sizeof(buf)-1, "s3x clear %s", get_env_or_die("SVNZOO_BUCKET"));
  buf[sizeof(buf)-1] = '\0';
  system(buf);

  // Initialize s3vn configuration
  init_s3vn( tmp_repo_name,
             get_env_or_die("SVNZOO_BUCKET"),
             get_env_or_die("SVNZOO_PREFIX"),
             get_env_or_die("SVNZOO_ZKADDR"),
             get_env_or_die("SVNZOO_ZKPREFIX")
           );

  // Connect to ZooKeeper
  rc = create_session();
  if (rc == -1)
  {
    fprintf(stderr, "Could not connect to ZooKeeper\n");
    exit(1);
  }

  // Create a repository locally
  rc = create_local_repo();
  if (rc == -1)
  {
    fprintf(stderr, "Could not create local repository\n");
    exit(1);
  }

  // Store the repository in S3/ZooKeeper
  store_repo();

  // Disconnect from ZooKeeper
  end_session();

  return 0;
}
